"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var lodash_1 = require("lodash");
var HtmlEditorFloatHighlightToolbar = function (props) {
    var editor = props.editor;
    var _a = (0, react_1.useState)(false), showInlineEditNoteUI = _a[0], setShowInlineEditNoteUI = _a[1];
    var InlineEditNoteUI = null;
    var colors = (0, lodash_1.isArray)(props.colors) && props.colors.length > 0 ? props.colors : [
        primeobjects_helper_util_1.COLORS.RED['100'],
        primeobjects_helper_util_1.COLORS.ORANGE['100'],
        primeobjects_helper_util_1.COLORS.BLUE['100'],
        primeobjects_helper_util_1.COLORS.GREEN['100'],
        primeobjects_helper_util_1.COLORS.GRAY['100'],
    ];
    var onClickEditNote = function () {
        if (!(0, lodash_1.isFunction)(props.onClickEditNote))
            return;
        InlineEditNoteUI = props.onClickEditNote(editor);
        setShowInlineEditNoteUI(true);
        //if result is not null, it is an inline editor, it will use the same block of tool bar
    };
    var onApplyColor = function (color) {
        if (editor.isActive('hightlight', { color: color })) {
            editor.chain().focus().unsetHighlight();
        }
        else {
            editor.chain().focus().toggleHighlight({ color: color }).run();
        }
        if ((0, lodash_1.isFunction)(props.onHighlight))
            props.onHighlight(editor, color);
    };
    var renderColorPicker = function () {
        if (showInlineEditNoteUI)
            return null;
        return (0, lodash_1.map)(colors, function (color) {
            var isActive = editor.isActive('hightlight', { color: color });
            return react_1.default.createElement("div", { className: "menu", key: color },
                react_1.default.createElement("div", { onClick: function () { return onApplyColor(color); }, style: { backgroundColor: color }, className: "menu-color ".concat(isActive ? 'active' : '') }, isActive && react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/checkmark.svg", size: 12 })));
        });
    };
    var renderEditNoteButton = function () {
        if (!(0, lodash_1.isFunction)(props.onClickEditNote) || showInlineEditNoteUI)
            return null;
        return react_1.default.createElement("div", { className: "menu border border-0 border-l flex", style: { marginLeft: 3, paddingLeft: 3 } },
            react_1.default.createElement("div", { onClick: onClickEditNote, className: "menu-color", style: { width: 16, height: 16 } },
                react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/note.svg", style: { width: 18 } })));
    };
    var renderEditNoteUI = function () {
        return InlineEditNoteUI;
    };
    return react_1.default.createElement(react_2.BubbleMenu, { editor: editor, className: "menu-wrapper" },
        renderColorPicker(),
        renderEditNoteButton(),
        renderEditNoteUI());
};
exports.default = HtmlEditorFloatHighlightToolbar;
